"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _config = require("@spockjs/config");

var _assertionBlock = _interopRequireWildcard(require("@spockjs/assertion-block"));

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

const transformLabeledBlockOrSingle = (transform, path) => {
  const labeledBodyPath = path.get('body');

  switch (labeledBodyPath.type) {
    case 'BlockStatement':
      // power-assert may add statements in betweeen,
      // so never reuse body array
      const statementPaths = () => labeledBodyPath.get('body');

      statementPaths().forEach(transform); // remove label

      path.replaceWithMultiple(statementPaths().map(stmtPath => stmtPath.node));
      break;

    default:
      transform(labeledBodyPath); // remove label

      path.replaceWith(labeledBodyPath);
  }
};

var _default = babel => ({
  visitor: {
    LabeledStatement(path, state) {
      const config = (0, _config.extractConfigFromState)(state);
      const label = path.node.label.name; // assertion block

      if (_assertionBlock.labels.includes(label)) {
        transformLabeledBlockOrSingle((0, _assertionBlock.default)(babel, state, config), path);
      }
    }

  }
});

exports.default = _default;